:*******************************************************************
:  VSTOP.bat
:  Script to stop Voice and other services of the Enterprise Edge
:  
:  Version 1.0 for EE RC 6.0c Shared Files
:  Date Sept, 99  Tim Wood
:  Revision 01 May 30, 2000 K. Parry
:           Added handlers for "Backup" parameter to skip TAPI shutdown
:*******************************************************************
@echo off
if "%1%" == "Backup" set echo=ON
@if not "%ECHO%"=="" echo %ECHO%
@if not "%OS%" =="Windows_NT" goto QUIT
REM vstop for EE
REM Stop all Services and Devices
REM make sure all service activity is quiet...
set RC=0
CALL servicesup.bat
REM stop watchdog so it doesn't auto-restart anything
Call :Stopit voicewatchdog
goto skip_tapi
REM stop TAPISRV and all dependents
if "%1%" == "Backup" (
	@echo Vstop called with %1% parameter, TAPI will not be shutdown.
	goto skip_tapi
	)
start Servutil.exe -stopall tapisrv
call :waitnoServutil
REM do it twice as once is not enough....
start Servutil.exe -stopall tapisrv
call :waitnoServutil
REM kill mtt.exe, acd.exe, ctediag.exe, rdbserver.exe
:skip_tapi

pushd .
%systemdrive%
cd "%systemdrive%\Program Files\Nortel Networks\Voice Platform\"
REM kill.exe mtt.exe
kill.exe CteDiag.exe
kill.exe acd.exe
Kill.exe RDBServer.exe
popd

REM stop all dependents of VoiceCTI first
Servutil.exe -stopall VoiceCTI
if not %ERRORLEVEL% == 0 GOTO ERREXIT
REM to be sure, re-kill mtt.exe, acd.exe, ctediag.exe, cte.exe, rdbserver.exe
pushd .
%systemdrive%
cd "%systemdrive%\Program Files\Nortel Networks\Voice Platform\"
REM kill.exe mtt.exe
kill.exe CteDiag.exe
kill.exe acd.exe
Kill.exe RDBServer.exe
popd
REM now stop all dependents of the MSC Service
Servutil.exe -stopall VoiceMSCService
if not %ERRORLEVEL% == 0 GOTO ERREXIT

REM now stop all dependents of the MSC Driver
Servutil.exe -stopall VoiceMSCDriver
if not %ERRORLEVEL% == 0 GOTO ERREXIT


Call :Stopit VoiceNetQoSMonitor
Call :Stopit "Voice Net QoS Monitor"
Call :Stopit CTEdiaglogger
Call :Stopit MSPDaemons
Call :Stopit "Tivoli Endpoint"
Call :Stopit trip

miserver /shutdown
goto QUIT
:stopit
if not exist %systemdrive%"\Program Files\Nortel Networks\Voice Platform\serviceinstalled.vbs" goto S1
cscript %systemdrive%"\Program Files\Nortel Networks\Voice Platform\serviceinstalled.vbs" %1 //NoLogo 
if not %errorlevel% == 0 goto EOF
:S1
net stop %1 /Y
goto EOF
:ERREXIT
set RC=%errorlevel%
REM dump out status of all services
setlocal
if not exist "%~d0\%~p0\logs\" MD "%~d0\%~p0\logs\"
set logfile="%~d0\%~p0\logs\%~n0.log"
call :timestamp
echo %thisdate% %thistime% >> %logfile%
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\SC.EXE" query type= driver bufsize= 8192 >> %logfile%
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\SC.EXE" query state= all bufsize= 8192 >> %logfile%
endlocal
goto EOF
:TIMESTAMP
for /f "tokens=2" %%i in ('date /t') do set thisdate=%%i
for /f %%i in ('time /t') do set thistime=%%i
goto EOF
:MoreWaitNoServutil
sleep 1 >%TEMP%\%~n0.txt
Echo Stopping Services...
:WaitNoServutil
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\pulist.exe" | find /I "Servutil.exe" >%TEMP%\%~n0.txt
if %errorlevel% == 0 goto :MoreWaitNoServutil
goto EOF
:EOF
:QUIT