@echo off
@if not "%ECHO%"=="" echo %ECHO%
@if not "%OS%" =="Windows_NT" goto EOF
REM first setup system environment vars
set nostop=
set nostart=
CALL :SetNNProductVars 
CALL :ParseArgs %*
echo This is the patch wizard for Nortel Networks %ProductKey:"=%
echo This system is currently running Release %ReleaseID:"=%, version %VersionID:"=%
if not %ProductKey% == "Voice" echo Nortel Networks %ProductKey:"=% Build ID %Version:"=% Registry Profile %RegID:"=%
echo This script will perform the following actions:
echo 1.) Validate the environment to help ensure that all required files are 
echo     present to apply the patch. 
echo 2.) Optionally stop all Nortel Networks %ProductKey:"=% services
echo 3.) Run the patch script to update the component
echo 4.) Update the patchHistory.log file
echo 5.) Optionally start all the Nortel Networks %ProductKey:"=% services
echo *
echo It is recommended that all non-essential applications be
echo closed on the server, including any web browser on the server or
echo on a remote system. 
echo *
set Failtext=Patch application aborted by the user

if "%NoPrompt%"=="" choice /C:ASPC /N /t:C,5 Step 1 will commence in 5 seconds. Press A to abort, S to skip, P to pause, C to continue 
if %errorlevel% == 1 goto UpgradeAbort
if %errorlevel% == 2 goto endStep1
if %errorlevel% == 3 pause
:step1
REM make sure we have everything to do the patch application
echo Proceeding with step 1, validating the environment
set logfile="c:\program files\nortel networks\voice platform\logs\%patchID%.log"
set xmlfile="d:\data files\nortel networks\patches\patchHistory.xml"
if not exist "c:\program files\nortel networks\voice platform\wwwroot\patches\logs" mkdir "c:\program files\nortel networks\voice platform\wwwroot\patches\logs"
if not exist "d:\data files\nortel networks\patches" mkdir "d:\data files\nortel networks\patches"
call :timestamp
echo %thisdate% %thistime% - Patch application %Upfunction% for Nortel Networks %ProductKey:"=% %ReleaseID:"=%, version %VersionID:"=% >> %logfile%
if not %ProductKey% == "Voice" echo %thisdate% %thistime% - Nortel Networks %ProductKey:"=% Build ID %RegID:"=% Registry Profile %RegID:"=%>> %logfile%
echo %thisdate% %thistime% - Proceeding with step 1, validating the environment>> %logfile%

set FailText=File %runPatch% does not exist.
if not exist %runPatch% set runPatch="%~d0%~p0%runPatch%"
if not exist %runPatch% goto UpgradeAbort
call :timestamp
echo %thisdate% %thistime% - Patch to apply %runPatch% exists. >>%logfile%

REM check to see if Windows script host is installed
set FailText=Windows Script Host is not present. Please install before running the patch.
if not exist %windir%\system32\cscript.exe goto UpgradeAbort



echo Environment is OK.
call :timestamp
echo %thisdate% %thistime% - Environment is OK. >> %logfile%
:endstep1

echo To proceed with the next step, shutdown of all services,

set Failtext=Patch application aborted by the user
if "%NoPrompt%"=="" choice /C:ASPC /N /t:C,5 Step 2 will commence in 5 seconds. Press A to abort, S to skip, P to pause, C to continue
if %errorlevel% == 1 goto UpgradeAbort
if %errorlevel% == 2 goto endStep2
if %errorlevel% == 3 pause

:step2
if "%nostop%" == "1" goto endStep2
echo Proceeding with step 2, shutdown of all services
call :timestamp
echo %thisdate% %thistime% - Proceeding with step 2, shutdown of all services >>%logfile%
call servicesup.bat
set RC=0
Call vstop.bat
if not %RC% == 0 GOTO ERRORContinue
call :timestamp
echo %thisdate% %thistime% - Services shutdown from vstop >> %logfile%
:Proceed
echo All Nortel Networks %ProductKey:"=% services have been stopped.
:endStep2
echo To proceed with the next step, applying the patch %runPatch%,

set Failtext=Patch application aborted by the user
if "%NoPrompt%"=="" choice /C:ASPC /N /t:C,5 Step 3 will commence in 5 seconds. Press A to abort, S to skip, P to pause, C to continue
if %errorlevel% == 1 goto UpgradeAbort
if %errorlevel% == 2 goto endStep3
if %errorlevel% == 3 pause
:step3
REM call the apply script
set Failtext=Failed to apply patch runPatch%
set RC=0
call %runPatch% 
if not %RC% == 0 GOTO PatchError  
echo Patch %runPatch% applied
call :timestamp
echo %thisdate% %thistime% - Patch %runPatch% applied >>%logfile%
:endStep3
echo To proceed with the next step, updating the patchHistory.xml file,

set Failtext=Patch application aborted by the user
if "%NoPrompt%"=="" choice /C:ASPC /N /t:C,5 Step 4 will commence in 5 seconds. Press A to abort, S to skip, P to pause, C to continue
if %errorlevel% == 1 goto UpgradeAbort
if %errorlevel% == 2 goto endStep4
if %errorlevel% == 3 pause
:step4
REM Patch applied correctly, update the PatchHistory.xml file
echo Updating the PatchHistory.xml file
call :timestamp
echo %thisdate% %thistime% - Updating the PatchHistory.xml file >>%logfile%
echo ^<Patch PatchID="%patchID%" PatchScript="%runPatch:"=%" DateApplied="%thisdate% %thistime%" Profile="%RegID:"=%" ApplicationRelease="%ReleaseID:"=%" ApplicationVersion="%VersionID:"=%"^/^> >>%xmlfile%

REM make apache non-interactive
call :ApacheNonInt
REM save the registry profile
call :saveRegistry
:endStep4
if not "%nostart%" == "1" call vstart.bat
echo Application of patch %runPatch% completed.
call :timestamp
echo %thisdate% %thistime% - Application of patch %runPatch% completed. >>%logfile%
goto EOF

:saveRegistry

if not exist %systemdrive%"\Program Files\Nortel Networks\Voice Platform\saveregprofile.bat" goto EOF
echo Now saving the current registry settings within the profile
call %systemdrive%"\Program Files\Nortel Networks\Voice Platform\saveregprofile.bat"
echo Registry backed up into Profile%RegID%
call :Timestamp
echo %thisdate% %thistime% - Registry backed up into Profile%RegID%>>%logfile%
goto EOF

:shutdown
:S1
echo The upgrade has been applied to the system, but it needs to proceed with the next step.
set Failtext=Server restart aborted by the user
echo To proceed with the server restart,
if "%NoPrompt%"=="" choice /C:ASPC /N /t:C,5 Step 8 will commence in 5 seconds. Press A to abort, S to skip, P to pause, C to continue
if %errorlevel% == 1 goto UpgradeAbort
if %errorlevel% == 2 goto eof
if %errorlevel% == 3 pause
:step8
%systemdrive%
cd "%systemdrive%\Program Files\Nortel Networks\Voice Platform\"
call :Timestamp
REM echo %thisdate% %thistime% - Restarting... >>%logfile%
shutdown.exe /l /r /t:2 /y "Restarting..."
Goto EOF

REM =========================== UTILITIES ===============================

:ApacheNonInt
REM regedit /s "%systemdrive%\Program Files\Nortel Networks\Voice Platform\unrunatboot.reg"
call :timestamp
echo %thisdate% %thistime% - Making Apache service non-interactive >>%logfile%
echo Making Apache service non-interactive
REG UPDATE HKLM\System\CurrentControlSet\Services\Apache\Type=10
soon 65 apachenon.bat
goto EOF

:ERRORContinue
call :timestamp
echo %thisdate% %thistime% - Exit code of %RC% from stopping services. >>%logfile%
echo Exit code of %RC% from stopping services.
echo Aborting the patch application, please investigate why services failed to stop.
REM if "%NoPrompt%"=="" PAUSE 
call :timestamp
echo %thisdate% %thistime% - Patch application aborted. >>%logfile%
goto EOF

:MoreWaitNoUnInstall
sleep 1 >%TEMP%\%~n0.txt
:WaitNoUnInstall
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\pulist.exe" | find /I "IsUninst.exe" >%TEMP%\%~n0.txt
if %errorlevel% == 0 goto MoreWaitNoUnInstall
goto EOF


:OMoreWaitNoInstall
sleep 1 >%TEMP%\%~n0.txt
:OWaitNoInstall
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\pulist.exe" | find /I "_ISDel.exe" >%TEMP%\%~n0.txt
if %errorlevel% == 0 goto OMoreWaitNoInstall
goto EOF

:SetNNProductVars
REM check to see if we have the nnproduct.vbs installed
set ProductKey="Voice"
if not exist "%systemdrive%\Program Files\Nortel Networks\Voice Platform\nnproduct.vbs" goto EOF
for /f "tokens=1,2" %%i in ('cscript "%systemdrive%\Program Files\Nortel Networks\Voice Platform\nnproduct.vbs" //NoLogo') do set %%i %%j
goto EOF
:TIMESTAMP
for /f "tokens=2" %%i in ('date /t') do set thisdate=%%i
for /f %%i in ('time /t') do set thistime=%%i
goto EOF

:ParseArgs
if "%1" == "" goto EOF
if not %1 == "/NoPrompt" goto P1
set NoPrompt=on
:doShift
shift
call :ParseArgs %1 %2 %3 %4 %5 %6 %7 %8 %9
goto EOF
:P1

if "%1" == "/nostop" goto P2
if "%1" == "/noStop" goto P2
if "%1" == "/nostart" goto P3
if "%1" == "/noStart" goto P3
set runPatch=%1
set patchID=%~n1
goto doShift

:P2
set nostop=1
goto doShift

:P3
set nostart=1
goto doShift

:KillWaitKill
pushd .
%systemdrive%
cd "%systemdrive%\Program Files\Nortel Networks\Voice Platform"
echo Killing waitkill.exe
echo Killing waitkill.exe >>%logfile%
start /w kill56.exe waitkill
set RC=%errorlevel%
echo Exit Code %RC% from kill56.exe
echo Exit Code %RC% from kill56.exe >>%logfile%
popd
goto EOF

:GetUpgradeProgress
set upgradeProgressMark=
for /f "tokens=1,2" %%i in ('cscript "%systemdrive%\Program Files\Nortel Networks\Voice Platform\readupgprogress.vbs" //NoLogo') do set %%i %%j
goto EOF

:SetUpgradeProgress
set upgradeProgressMark=%1
if not "%1" == "" goto saveUpgradeProgressMark
cscript "%systemdrive%\Program Files\Nortel Networks\Voice Platform\clrupgprogress.vbs" //NoLogo
goto EOF
:saveUpgradeProgressMark
cscript "%systemdrive%\Program Files\Nortel Networks\Voice Platform\saveupgprogress.vbs" %1 //NoLogo
goto EOF


:CheckISSLog
echo Checking installation of %1
call :timestamp
set component=%1
echo %thisdate% %thistime% - Checking installation of %component% >>%logfile%
if exist %runDrive%"\Nortel Networks\Enterprise Edge Upgrade\Comps\%component:"=%\setup.log" goto ISSExist
echo %runDrive%"\Nortel Networks\Enterprise Edge Upgrade\Comps\%component:"=%\setup.log" does not exist
echo %thisdate% %thistime% - %runDrive%"\Nortel Networks\Enterprise Edge Upgrade\Comps\%component:"=%\setup.log" does not exist >>%logfile%
goto EOF
:ISSExist
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\isslookup.exe" %runDrive%"\Nortel Networks\Enterprise Edge Upgrade\Comps\%component:"=%\setup.log"
set RC=%errorlevel%
if %RC% == 0 goto CheckISSLogOK
REM log output to logfile
set component=%1
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\isslookup.exe" %runDrive%"\Nortel Networks\Enterprise Edge Upgrade\Comps\%component:"=%\setup.log" >>%logfile%
goto EOF

:CheckISSLogOK
echo %1 installation is OK
call :timestamp
echo %thisdate% %thistime% - %1 installation is OK >>%logfile%
goto EOF

:patchError
echo .
echo ^<script^>errorAlert^("Patch Application Error", 0, "<CENTER>%FailText%</CENTER>"^);^<^/script^>
goto EOF

:UpgradeAbort
echo ***Error: Patch application aborted; Reason:
echo %FailText%
if "%NoPrompt%"=="" PAUSE
Goto EOF
:EOF