:*******************************************************************
:  RegProfileSwap.cmd
:  Script to enable the swap out of default registry profiles for 
:  Enterprise Edge
:  Version 2.0.2.2 for EE 1000 Rls 2.0 Platform Services
:  Date Sep. 13, 99  
:  Revision 1.6 Sept 19, 1999 K Parry
:                        Added the conditional cls for debug
:                        remarked out the Int'l profiles
:  Revision 1.7 Sept 20, 1999 K Parry
:                        added ras swap functionality
:  Revision 1.8 Nov. 5, 1999 K Parry
:                        added if exist ... del lnk and Abort option to shutdown
:  Revision 1.9 Nov. 5, 1999 K Parry
:                        redirected all error messages to %logfile%
:                        changed the profile 3 IWAN  and NIC2 locations
:  Revision 2.0 Nov. 17, 1999 K Parry
:                        Added check to ensure that the Uploading is not in progress
:								 Added Time-Stamp procedure also.
:  Revision 2.1 Dec. 2, 1999 K Parry
:                        Changed to search for * rather than cmd.lnk
:  Revision 2.2 Dec. 2, 1999 K Parry
:                        Changed profile 3 back again
:  Revision 2.3 May 23, 2000 T Wood
:                        Added removal of routepatch%profileNumber%.ran
:  Revision 2.4 May 25, 2000 T Wood
:*******************************************************************

@echo off
@if not "%ECHO%"=="" echo %ECHO%
@if not "%OS%" =="Windows_NT" GOTO EXIT
set norteldir="c:\program files\Nortel Networks\"
set logfile=%TEMP%\regswap.log
CALL :TIMESTAMP
echo *=====================*
echo %thisdate% %thistime% Start Registry swap. > %logfile%
IF NOT EXIST %SystemRoot%\LASTPROF MD %SystemRoot%\LASTPROF 2>&1 >>%logfile%
IF NOT EXIST %SystemRoot%\NEWPROF MD %SystemRoot%\NEWPROF 2>&1 >>%logfile% 
DEL %SystemRoot%\LASTPROF\*.* /Q   2>&1 >>%logfile%
DEL %SystemRoot%\NEWPROF\*.* /Q 	 2>&1 >>%logfile%
if not "%1" == "" (set selection=%1) & (goto Selection)
echo Selection is %selection%
:Start
if not "%ECHO%"=="on" cls
Echo *=============================================================================*
Echo   Nortel Networks                                       Enterprise Edge 1000
Echo *=============================================================================*
Echo. 
echo Choose a PCI Slot Registry Profile that matches this system:
echo.
echo                               Slot1   Slot2   Slot3   Slot4      MBMs
echo                             *===============================*
echo          1.- EE-WVMN-CONFIG [   WAN :  V.90 :  MSC  :  NIC  ]
echo          2.- EE-NVMN-CONFIG [   NIC :  V.90 :  MSC  :  NIC  ] 
echo          3.- EE-INMN-CONFIG [  IWAN :  NIC  :  MSC  :  NIC  ]
echo          4.- EE-N_MN-CONFIG [   NIC :       :  MSC  :  NIC  ]  
echo          5.- EE-xxMN-CONFIG [   n/a :  n/a  :  MSC  :  NIC  ]  
echo.
echo          Q.- Quit
echo.
echo Notes: 
echo Selecting a profile will set the system settings back to factory default.
echo Selecting 5 will place in you in CoreUpload mode, all settings will be 
echo replaced by factory default settings.
echo. 

CHOICE /C:12345Q PRESS A NUMBER
set selection=%ERRORLEVEL%
:Selection
echo.
CALL :TIMESTAMP
echo %thisdate% %thistime% Profile %selection% selected. 2>&1 >> %logfile%
if %selection% == 6 GOTO Quit 
REM Check to ensure that the upload is not in progress.
CALL :NoUploadInProgress
echo No upload is in progress
set errmsg=Unable to copy profile%selection% files
copy %SystemRoot%\profile%selection%\*.* %SystemRoot%\newprof 2>&1 >> %logfile%
If NOT %ERRORLEVEL% == 0 GOTO Error 
echo Copied registry profile files
:END
set errmsg=Unable to restore registry for profile%selection%
REGREST %SystemRoot%\NEWPROF %SystemRoot%\LASTPROF 2>&1 >> %logfile%
if %ERRORLEVEL% == 2 GOTO error
echo Restore registry settings into LASTPROF
set errmsg=Looklog failed to restore the Users hive
call looklog.exe %logfile% %SystemRoot%\Newprof\Users %SystemRoot%\Lastprof\Users /l %logfile%
if not %ERRORLEVEL% == 0 GOTO error
echo Restored users hive into LASTPROF
copy %logfile%+%TEMP%\LOOKLOG.LOG %logfile%
if "%selection%" == "5" goto setMSC
set errmsg=Unable to delete the RAS files
if exist %SystemRoot%\system32\ras\ras.ico attrib -r %SystemRoot%\system32\ras\ras.ico
del  %SystemRoot%\system32\ras /Q  2>&1 >> %logfile%
if not %ERRORLEVEL% == 0 GOTO error
echo Deleted the RAS files
set errmsg=Unable to replace the RAS files for profile%selection%
copy %SystemRoot%\system32\ras%selection%  %SystemRoot%\system32\ras  2>&1 >>%logfile%
if not %ERRORLEVEL% == 0 GOTO error
echo Replaced the RAS files
REM Remove the routepatch%selection%.ran file 
if exist "%systemdrive%\Program Files\Nortel Networks\Voice Platform\routepatch%selection%.ran" DEL "%systemdrive%\Program Files\Nortel Networks\Voice Platform\routepatch%selection%.ran"
:setMSC
call :setMSCCFGFile
echo Set the MSC CFG file
REM call the resetsubsys
call "%systemdrive%\Program Files\Nortel Networks\Voice Platform\resetsubsys.cmd"
REM Next section copies a shortcut to the startup group to run resetSubsys.cmd at startup
REM copy  %norteldir%"Voice Platform\"resetSubsys.cmd.lnk "C:\winnt\Profiles\All Users\Start Menu\Programs\Startup" 2>&1 >>%logfile%
REM if not %ERRORLEVEL% == 0 GOTO error
REM Next line removes the link from the startup menu for this script.
set errmsg=Unable to delete shortcut from the Startup menu
if exist "C:\winnt\Profiles\All Users\Start Menu\Programs\Startup\RegProfileSwap.*" del "C:\winnt\Profiles\All Users\Start Menu\Programs\Startup\RegProfileSwap.*" /Q 2>&1 >>%logfile%
if not %ERRORLEVEL% == 0 GOTO error
REM Resetting the Server.
echo Ready to restart the server
sleep 3>NUL
if not "%ECHO%"=="on" cls
echo +E3 >com2 
choice /C:AU /N "This server will begin a server restart in 5 seconds. Press 'A' to abort" /t:U,5
if "%ERRORLEVEL%"== "1" GOTO EOF
echo This server is restarting in 5 seconds...Please wait 
echo %thisdate% %thistime%  System shut down in progress >> %logfile%
if not "%ECHO%"=="on" shutdown  /L /T:5 /R /C /Y
sleep 10 > NUL
if not "%ECHO%"=="on" exit
GOTO EOF
:Not_Appl
echo %selection% is not supported at this time.
sleep 2 > NUL
GOTO Start
REM PROCEDURE TIMESTAMP
:TIMESTAMP
for /f "tokens=2" %%i in ('date /t') do set thisdate=%%i
for /f %%i in ('time /t') do set thistime=%%i
GOTO EOF
REM Procedure NoUploadInProgress checks if an upload has been started, if so will not
REM allow the reg profile swap to start.
:NoUploadInProgress
"%systemdrive%\Program Files\Nortel Networks\Voice Platform\pulist.exe" | find /I "Uploader.exe" >%TEMP%\find.txt
if not %errorlevel% == 0 GOTO EOF
REM an uploader is already running
if not "%ECHO%"=="on" cls
CALL :TIMESTAMP
echo %thisdate% %thistime% Aborted, upload detected. >> %logfile%
echo. 
echo CAUTION! There is an KSU upload in progress. 
echo Setting a profile requires a reboot, doing this while 
echo an upload is in progress can result in a hung system. 
echo Please wait until the upload is complete before re-trying.
sleep 10 > NUL
GOTO Start
:setMSCCFGFile
if "%selection%" == "5" goto profile5
copy %systemdrive%"\Program Files\Nortel Networks\Voice CTI\runtime\ds30msc.cfg" %systemdrive%"\Program Files\Nortel Networks\Voice CTI\runtime\ds30.cfg"
goto EOF
:profile5
if "%selection%" == "5" copy %systemdrive%"\Program Files\Nortel Networks\Voice CTI\runtime\ds30dnld.cfg" %systemdrive%"\Program Files\Nortel Networks\Voice CTI\runtime\ds30.cfg"
call :mkAutoEtqShortcut
goto EOF

:mkAutoEtqShortcut
echo Creating autorunetc shortcut in the start menu
pushd .
%systemdrive%
cd "C:\winnt\profiles\All Users\Start Menu\Programs\Startup"
cscript "C:\program files\nortel networks\voice platform\mkshortcut.vbs" AutoRunEtq.lnk "C:\program files\nortel networks\voice platform\autorunetq.cmd"
popd
goto EOF

:error
Echo Error: %ERRORLEVEL% %errmsg%
sleep 5 > NUL
:Quit
:EOF
